unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    procedure Stirling_Numbers(no : integer);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// ̌Œ蒷stringϊ
// o 
// l string
function spstr(o, l: integer) : string;
const
  sp = ' ';
var
  lng, i : integer;
  s : string;
begin
  result := '';
  s := inttostr(o);
  lng := length(s);
  for i := 1 to l - lng do result := result + sp;
  result := result + s;
end;

// n=0 k= 0@1ƒ`܂
// no X^[ONo
function Stirling(n, k , no: integer): integer;
var
  m : integer;
begin
  if k= n then begin
    result := 1;
    exit;
  end;
  if (k < 1) or (k > n) then begin
    result := 0;
    exit;
  end;
  m := 0;
  case no of
    1: m := (n - 1);
    2: m := k;
  end;
  result := m * Stirling(n - 1, k, no) + Stirling(n - 1, k - 1, no);
end;

// no X^[ONo
procedure TForm1.Stirling_Numbers(no : integer);
const
  km = 9;
  nm = 9;
var
  n, k, st : integer;
  ostr : string;
begin
  memo1.Clear;
  case no of
    1: ostr := 'Stirling number of the first kind';
    2: ostr := 'Stirling number of the second kind';
  end;
  memo1.Lines.Append(ostr);
  memo1.Lines.Append('');
  ostr := '  k  0';
  for k := 1 to km do
    ostr := ostr + spstr(k, 7);
  memo1.Lines.Append(ostr);
  ostr := 'n ----' ;
  for k := 1 to km do
    ostr := ostr + '-------';
  memo1.Lines.Append(ostr);
  ostr := '';
  for n := 0 to nm do begin
    ostr := spstr(n, 2) + '|';
    k := 0;                           // ŏ̗  k=0 st3
    st := Stirling(n, k, no);
    ostr := ostr + spstr(st, 3);
    for k := 1 to n do begin          // k=1` st7
      st := Stirling(n, k, no);
      ostr := ostr + spstr(st, 7)
    end;
    memo1.Lines.Append(ostr);
  end;
end;

// Stirling number 1
procedure TForm1.Button1Click(Sender: TObject);
begin
  Stirling_Numbers(1);
end;

// Stirling number 2
procedure TForm1.Button2Click(Sender: TObject);
begin
  Stirling_Numbers(2);
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  memo1.clear;
  memo1.Text := 'Stirling number';
  memo1.Font.Name := 'lr ';
end;

end.
